Imports System
Imports System.Drawing
Imports System.Collections
Imports System.ComponentModel
Imports System.Windows.Forms

Imports Syncfusion.Diagnostics
Imports Syncfusion.Windows.Forms.Grid
Imports Syncfusion.Drawing

'/ <summary>
'/ Summary description for Form1.
'/ </summary>

Public Class Form1
    Inherits System.Windows.Forms.Form
    Private WithEvents gridControl1 As Syncfusion.Windows.Forms.Grid.GridControl
    '/ <summary>
    '/ Required designer variable.
    '/ </summary>
    Private components As System.ComponentModel.Container = Nothing


    Public Sub New()
        '
        ' Required for Windows Form Designer support
        '
        InitializeComponent()

        '
        ' TODO: Add any constructor code after InitializeComponent call
        '
        Dim model As GridModel = gridControl1.Model
        model.Options.FloatCellsMode = GridFloatCellsMode.OnDemandCalculation

        Dim boldFont As New GridFontInfo()
        boldFont.Bold = True
        boldFont.Size = 11
        boldFont.Underline = True

        Dim rowIndex As Integer = 2
        Dim colIndex As Integer = 1

        gridControl1.Rows.DefaultSize += 2
        Dim boldfontRowHeight As Integer = gridControl1.Rows.DefaultSize + 6

        model.Options.ControllerOptions = GridControllerOptions.All
        model.Options.DataObjectConsumerOptions = GridDataObjectConsumerOptions.All

        Dim standard As GridStyleInfo = model.BaseStylesMap("Standard").StyleInfo
        Dim header As GridStyleInfo = model.BaseStylesMap("Header").StyleInfo
        Dim rowHeader As GridStyleInfo = model.BaseStylesMap("Row Header").StyleInfo
        Dim colHeader As GridStyleInfo = model.BaseStylesMap("Column Header").StyleInfo

        rowHeader.Interior = New BrushInfo(SystemColors.Control)
        header.Interior = New BrushInfo(SystemColors.Control)
        'standard.Font.Size = 9;
        standard.Font.Facename = "Helvetica"

        model.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
        model(rowIndex, 1).Text = "Number Formats"
        model(rowIndex, 1).Font = boldFont
        model.RowHeights(rowIndex) = boldfontRowHeight
        rowIndex += 1

        colIndex = 1
        rowIndex += 1
        Dim format As String
        'For Each format In New String() {"0.00", "C", "0.00;(0.00)", "###0.##%", "#0.#E+00", "10:##,##0.#"}
        For Each format In New String() {"#", "C", "0.00;(0.00)", "###0.##%", "#0.#E+00", "10:##,##0.#"}
            model(rowIndex - 1, colIndex).Text = format
            model(rowIndex, colIndex).Format = format
            model(rowIndex, colIndex).CellValue = 0.0 ' Math.PI
            model(rowIndex, colIndex).CellValueType = GetType(Double)
            colIndex += 1
        Next format

        rowIndex += 1
        rowIndex += 1

        colIndex = 1

        model.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
        model(rowIndex, 1).Text = "DateTime Formats"
        model(rowIndex, 1).Font = boldFont
        model.RowHeights(rowIndex) = boldfontRowHeight
        rowIndex += 1

        colIndex = 1
        rowIndex += 1
        Dim format1 As String
        For Each format1 In New String() {"d", "D", "f", "dddd, dd MMMM yyyy", "t", "s"}

            model(rowIndex - 1, colIndex).Text = format1
            model(rowIndex, colIndex).Format = format1
            model(rowIndex, colIndex).CellValue = DateTime.Now
            model(rowIndex, colIndex).CellValueType = GetType(DateTime)
            colIndex += 1
        Next format1

        rowIndex += 1
        rowIndex += 1

        model.CoveredRanges.Add(GridRangeInfo.Cells(rowIndex, 1, rowIndex, 2))
        model(rowIndex, 1).Text = "Validation"
        model(rowIndex, 1).Font = boldFont
        model.RowHeights(rowIndex) = boldfontRowHeight
        rowIndex += 1

        model(rowIndex, 1).Text = "Positive numbers"
        model.RowStyles(rowIndex).ValidateValue.NumberRequired = True
        model.RowStyles(rowIndex).ValidateValue.Minimum = 0
        model.RowStyles(rowIndex).ValidateValue.Maximum = Single.NaN
        model.RowStyles(rowIndex).ValidateValue.ErrorMessage = "Please enter a number greater than 0!"
        rowIndex += 1

        model(rowIndex, 1).Text = "Validation (1-100 valid range)"
        model.RowStyles(rowIndex).ValidateValue = New GridCellValidateValueInfo(True, 1, 100, "Please enter a number between 1 and 100!")
        rowIndex += 1
        rowIndex += 1

        model(rowIndex, 1).Text = "Validation (allow strings to be entered into cells with CellValueType = typeof(double)" '
        rowIndex += 1
        model.RowStyles(rowIndex).CellValueType = GetType(Double) '
        model.RowStyles(rowIndex).CellValue = 1 '
        model.RowStyles(rowIndex).Format = "C" '
        model.RowStyles(rowIndex).StrictValueType = False '
        rowIndex += 1
        rowIndex += 1

        model(rowIndex, 1).Text = "Validation (do not allow strings to be entered)" '
        rowIndex += 1
        model.RowStyles(rowIndex).CellValueType = GetType(Double) '
        model.RowStyles(rowIndex).CellValue = 1 '
        model.RowStyles(rowIndex).Format = "C" '
        model.RowStyles(rowIndex).StrictValueType = True '
        rowIndex += 1
        rowIndex += 1

        model(rowIndex, 1).Text = "Validation (change CellValueType when strings is entered)" '
        rowIndex += 1
        model.RowStyles(rowIndex).CellValueType = GetType(Double) '
        model.RowStyles(rowIndex).CellValue = 1 '
        model.RowStyles(rowIndex).Format = "C" '
        model.RowStyles(rowIndex).Tag = "Custom" '
        rowIndex += 1
        rowIndex += 1

        model.RowHeights.ResizeToFit(GridRangeInfo.Rows(2, rowIndex))
    End Sub 'New


    '/ <summary>
    '/ Clean up any resources being used.
    '/ </summary>
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub 'Dispose


    '/ <summary>
    '/ Required method for Designer support - do not modify
    '/ the contents of this method with the code editor.
    '/ </summary>
    Private Sub InitializeComponent()
        Me.gridControl1 = New Syncfusion.Windows.Forms.Grid.GridControl
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).BeginInit()
        Me.SuspendLayout()
        '
        'gridControl1
        '
        Me.gridControl1.Anchor = (((System.Windows.Forms.AnchorStyles.Top Or System.Windows.Forms.AnchorStyles.Bottom) _
                    Or System.Windows.Forms.AnchorStyles.Left) _
                    Or System.Windows.Forms.AnchorStyles.Right)
        Me.gridControl1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.gridControl1.ColCount = 8
        Me.gridControl1.HorizontalThumbTrack = True
        Me.gridControl1.Location = New System.Drawing.Point(24, 24)
        Me.gridControl1.Name = "gridControl1"
        Me.gridControl1.RowCount = 40
        Me.gridControl1.Size = New System.Drawing.Size(504, 321)
        Me.gridControl1.TabIndex = 3
        Me.gridControl1.Text = "gridControl1"
        Me.gridControl1.ThemesEnabled = True
        Me.gridControl1.VerticalThumbTrack = True
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(560, 374)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.gridControl1})
        Me.Name = "Form1"
        Me.Text = "Form1"
        CType(Me.gridControl1, System.ComponentModel.ISupportInitialize).EndInit()
        Me.ResumeLayout(False)

    End Sub 'InitializeComponent

    '
    '/ <summary>
    '/ The main entry point for the application.
    '/ </summary>
    <STAThread()> _
    Public Shared Sub Main()
        Application.Run(New Form1)
    End Sub 'Main




    Private Sub gridControl1_QueryCellFormattedText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs) Handles gridControl1.QueryCellFormattedText
        'TraceUtil.TraceCurrentMethodInfo(e);
    End Sub 'gridControl1_QueryCellFormattedText

    Private Sub gridControl1_QueryCellText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs) Handles gridControl1.QueryCellText
        'TraceUtil.TraceCurrentMethodInfo(e);
    End Sub 'gridControl1_QueryCellText


    Private Sub gridControl1_SaveCellText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs) Handles gridControl1.SaveCellText
        TraceUtil.TraceCurrentMethodInfo(e)
        ParseText(e)
    End Sub 'gridControl1_SaveCellText


    Private Sub gridControl1_SaveCellFormattedText(ByVal sender As System.Object, ByVal e As Syncfusion.Windows.Forms.Grid.GridCellTextEventArgs) Handles gridControl1.SaveCellFormattedText
        TraceUtil.TraceCurrentMethodInfo(e)
        ParseText(e)
    End Sub 'gridControl1_SaveCellFormattedText


    Sub ParseText(ByVal e As GridCellTextEventArgs)
        ' By default, the grid will display a warning message box informing the user
        ' the entered value is not valid and the user will have to change the value.
        '
        ' In this event handler we change the grid defaults behavior such that
        ' when the user enters a value that does not fit the cells CellValueType,
        ' the input text is accepted and no warning message is shown.
        If e.Handled OrElse e.Style.Tag Is Nothing OrElse Not e.Style.Tag.Equals("Custom") Then
            Return
        End If
        Dim ci As System.Globalization.CultureInfo = e.Style.CultureInfo
        Dim nfi As System.Globalization.NumberFormatInfo = Nothing
        If (Not (ci Is Nothing)) Then nfi = ci.NumberFormat
        Try
            e.Style.CellValue = GridCellValueConvert.Parse(e.Text, e.Style.CellValueType, nfi, e.Style.Format)
        Catch ex As Exception
            If TypeOf ex Is FormatException OrElse TypeOf ex.InnerException Is FormatException Then
                e.Style.CellValue = e.Text
                ' possibly could also change CellValueType here 
                e.Style.CellValueType = GetType(String)
                Console.WriteLine("Changed e.Style.CellValueType = typeof(string) for " + e.Style.Identity.ToString())
                ' - or -
                ' you could also further analyze the input text and assign a type
                ' that fits the input text, e.g.
                ' e.Style.CellValueType = typeof(datetime);
                ' - or - 
                ' e.Style.CellValueType = typeof(decimal);
                ' etc.
            Else
                Throw
            End If
        End Try
        e.Handled = True
    End Sub 'ParseText
End Class 'Form1